function valueChange(index)
{
	var cidr_index;

	if (document.getElementById("ip_oct_1").value > 255) document.getElementById("ip_oct_1").value = 255;
	if (document.getElementById("ip_oct_2").value > 255) document.getElementById("ip_oct_2").value = 255;
	if (document.getElementById("ip_oct_3").value > 255) document.getElementById("ip_oct_3").value = 255;
	if (document.getElementById("ip_oct_4").value > 255) document.getElementById("ip_oct_4").value = 255;
	if (document.getElementById("mask_bits").value > 32) document.getElementById("mask_bits").value = 32;
	if (document.getElementById("ip_oct_1").value < 0) document.getElementById("ip_oct_1").value = 0;
	if (document.getElementById("ip_oct_2").value < 0) document.getElementById("ip_oct_2").value = 0;
	if (document.getElementById("ip_oct_3").value < 0) document.getElementById("ip_oct_3").value = 0;
	if (document.getElementById("ip_oct_4").value < 0) document.getElementById("ip_oct_4").value = 0;
	if (document.getElementById("mask_bits").value < 1) document.getElementById("mask_bits").value = 1;
	switch(index) {
		case '0':
		case '1':	
			cidr_index = document.getElementById("cidr_netmask").value;
			break;
		case '2':
			cidr_index = document.getElementById("mask_bits").value-1;
			cidr_index = cidr_index.toString();
			break;
		case '3':
			cidr_index = document.getElementById("cidr_max_subnets").value;
			break;
		case '4':
			cidr_index = document.getElementById("max_addresses").value;
			break;
	}
	var bits = cidr_index;
	bits++;

	var snm1 = bits2d(bits);
	var snm2 = bits2d(cidr_index - 7);
	var snm3 = bits2d(cidr_index - 15);
	var snm4 = bits2d(cidr_index - 23);
	var nw1 = eval(snm1 & document.getElementById("ip_oct_1").value);
	var nw2 = eval(snm2 & document.getElementById("ip_oct_2").value);
	var nw3 = eval(snm3 & document.getElementById("ip_oct_3").value);
	var nw4 = eval(snm4 & document.getElementById("ip_oct_4").value);
	var broad1 = (nw1 ^ (~ snm1) & 255);
	var broad2 = (nw2 ^ (~ snm2) & 255);
	var broad3 = (nw3 ^ (~ snm3) & 255);
	var broad4 = (nw4 ^ (~ snm4) & 255);
	
	var pre_subnet = nw1 + "." + nw2 + "." + nw3 + ".";
	var pre_broadcast = broad1 + "." + broad2 + "." + broad3 + ".";
	var subnet = pre_subnet + nw4;
	var broadcast = pre_broadcast + broad4;
	var post_firstIP = (cidr_index=='31') ? nw4 : nw4 +1;
	var post_lastIP = (broad4=='0') ? broad4 :broad4-1;
	var range = pre_subnet + post_firstIP + " - " + pre_broadcast + post_lastIP;

	document.getElementById("cidr_netmask").value=index;
	document.getElementById("cidr_netmask-label").innerText = snm1 + "." + snm2 + "." + snm3 + "."  + snm4;
	document.getElementById("mask_bits").value=bits;
	document.getElementById("max_addresses").value=cidr_index;
	document.getElementById("max_addr-label").innerText = getMax_addr(cidr_index);
	document.getElementById("net_addr").innerText = subnet;
	document.getElementById("broad_addr").innerText = broadcast;
	document.getElementById("cidr_addr_range").innerText = range;
	document.getElementById("cidr_netmask").value = cidr_index;
}

function getMax_addr(index) {
//return index;
	switch(index) {
		case '0':
			return '2147483646';
		case '1':
			return '1073741822';
		case '2':
			return '536870910'
		case '3':
			return '268435454';
		case '4':
			return '134217726';
		case '5':
			return '67108862';
		case '6':
			return '33554430';
		case '7':
			return '16777214';
		case '8':
			return '8388606';
		case '9':
			return '4194302';
		case '10':
			return '2097150';
		case '11':
			return '1048574';
		case '12':
			return '524286';
		case '13':
			return '262142';
		case '14':
			return '131070';
		case '15':
			return '65534';
		case '16':
			return '32766';
		case '17':
			return '16382';
		case '18':
			return '8190';
		case '19':
			return '4094';
		case '20':
			return '2046';
		case '21':
			return '1022';
		case '22':
			return '510';
		case '23':
			return '254';
		case '24':
			return '126';
		case '25':
			return '62';
		case '26':
			return '30';
		case '27':
			return '14';
		case '28':
			return '6';
		case '29':
			return '2';
		case '30':
			return '1';
		case '31':
			return '0';
		default:
			return "a"+index+"a";
	}
}

function bits2d(binary) {		
	var decimal = 0;				
	if (binary > 0) { decimal = decimal + 128 }				
	if (binary > 1) { decimal = decimal + 64 }				
	if (binary > 2) { decimal = decimal + 32 }				
	if (binary > 3) { decimal = decimal + 16 }				
	if (binary > 4) { decimal = decimal + 8 }				
	if (binary > 5) { decimal = decimal + 4 }				
	if (binary > 6) { decimal = decimal + 2 }				
	if (binary > 7) { decimal = decimal + 1 }				
	return(decimal);	
}		

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

function showbackside(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("behind");
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  

    document.getElementById('fliprollie').style.display = 'none';
}

function showfrontside(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("behind");
        
    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    back.style.display="none";
    front.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

function gotoMacvaerk(event)
{
    if (window.widget)
    {
        widget.openURL('http://www.macvaerk.dtu.dk/');
    }
}




